package TVListings::Links;

use strict;
use warnings;

use CGI qw/escapeHTML/;
use CGI::Util qw/escape/;

use base qw/Exporter/;
our @EXPORT = qw/chanlink prglink searchlink attsearchlink
	imdbtlink imdbnlink personlink/;

sub chanlink($$$;$) {
	my ($r, $chanid, $text, $extra) = @_;
	my $id;
	$id = escapeHTML($extra->{id}) if defined $extra->{id};
	return qq{<a }
		. (defined $id ? qq{id="$id" name="$id" } : '')
		. qq{href="./chan?chan=$chanid">$text</a>};
}

sub prglink($$$) {
	my ($r, $prgid, $text) = @_;
	return qq{<a id="prg_$prgid" name="prg_$prgid" }
		. qq{href="./show?prg=@{[escape $prgid]}">$text</a>};
}

sub searchlink($$) {
	my ($query, $text) = @_;
	return qq{<a href="./search?q=@{[escape $query]}" }
		. qq{title="Search info in TV Listings">$text</a>};
}

sub imdbtlink($;$) {
	return q{<a href="http://imdb.com/find?tt=on;mx=20;q=}
		. escape($_[0]) . '" title="Search Title on IMDB">'
		. ($_[1] || escapeHTML($_[0])) . '</a>';
}

sub imdbnlink($;$) {
	return q{<a href="http://imdb.com/find?nm=on;mx=20;q=}
		. escape($_[0]) . '" title="Search Name on IMDB">'
		. ($_[1] || escapeHTML($_[0])) . '</a>';
}

sub personlink($) {
	return escapeHTML($_[0]) . '<sup>' . imdbnlink($_[0], "[i]")
		. searchlink($_[0], "[a]") . '</sup>';
}

1;
